

CREATE OR REPLACE FUNCTION fPrcPromo(
	_ItemID		VARCHAR,
	_Qty		NUMERIC, 
	_Unit		VARCHAR, 
	_SaleDate	DATE, 
	_BPID		VARCHAR, 
	_Total		NUMERIC,
	_BPGrpID	VARCHAR
) RETURNS SETOF tPrcPromo AS
$BODY$
DECLARE
	_retval		tPrcPromo%ROWTYPE;

	_Price		NUMERIC(19,4);
	_DiscExp	VARCHAR;
	_Selisih	NUMERIC;
	_OldSelisih	NUMERIC;
	_MinAmt		NUMERIC;

	_ModeBP		INT;
	_ModeItem	INT;
	
	_TBPType	VARCHAR;
	_TItemType	VARCHAR;

	cRetval		REFCURSOR;
BEGIN

	_retval.Price:=0;
	_retval.DiscExp:='';

	IF (_BPGrpID IS NOT NULL AND _BPID IS NOT NULL) THEN
		_ModeBP:=0;
	ELSIF (_BPID IS NOT NULL) THEN
		_ModeBP:=1;
	ELSE
		_ModeBP:=2;
	END IF;

	IF (_ItemID IS NOT NULL) THEN
		_ModeItem:=0;
	ELSIF (_ItemID IS NULL AND _Total>0) THEN
		_ModeItem:=1;
	END IF;

	IF (_ModeBP=0 AND _ModeItem=0) THEN
		--RAISE NOTICE '%', _ModeBP||' -> '||_ModeItem;

		SELECT INTO _Price, _DiscExp, _Selisih, _TBPType, _TItemType 
			price1, disc1exp, (fqtyztoqty1(_ItemID, _Qty, _Unit)-fqtyztoqty1(itemid, qty, unit)), tbptype, titemtype
		FROM pprc 
		WHERE active=TRUE 
		AND ((tbptype='BPGRP' AND fbpgrpin(_BPID, bpgrpid)) OR (tbptype='BPID' AND (custid=_BPID OR vendorid=_BPID)) OR (tbptype='ALL')) 
		AND (
			((titemtype='ITEM' AND itemid=_ItemID) AND unit=_Unit AND qty<=_Qty) OR 
			(titemtype='GROUP' AND itgrpid=(SELECT itgrpid FROM item WHERE itemid=_ItemID)) OR 
			(titemtype='BRAND' AND brandid=(SELECT brandid FROM item WHERE itemid=_ItemID))
		) 
		AND (startdate IS NULL OR startdate<=_SaleDate) AND (enddate IS NULL OR enddate>=_SaleDate);
		IF (FOUND) THEN
			_retval.price:=_Price;
			_retval.discexp:=_DiscExp;
		ELSE
			SELECT INTO _Price, _DiscExp, _Selisih, _TBPType, _TItemType 
				price1, disc1exp, (fqtyztoqty1(_ItemID, _Qty, _Unit)-fqtyztoqty1(itemid, qty, unit)), tbptype, titemtype
			FROM pprc 
			WHERE active=TRUE 
			AND ((tbptype='BPGRP' AND fbpgrpin(_BPID, bpgrpid)) OR (tbptype='BPID' AND (custid=_BPID OR vendorid=_BPID)) OR (tbptype='ALL')) 
			AND (
				((titemtype='ITEM' AND itemid=_ItemID) AND unit!=_Unit AND fqtyztoqty1(itemid, qty, unit)<=fqtyztoqty1(_ItemID, _Qty, _Unit)) OR 
				(titemtype='GROUP' AND itgrpid=(SELECT itgrpid FROM item WHERE itemid=_ItemID)) OR 
				(titemtype='BRAND' AND brandid=(SELECT brandid FROM item WHERE itemid=_ItemID))
			) 
			AND (startdate IS NULL OR startdate<=_SaleDate) AND (enddate IS NULL OR enddate>=_SaleDate); 
			IF (FOUND) THEN
				_retval.price:=_Price;
				_retval.discexp:=_DiscExp;
			END IF;
		END IF;

		RETURN NEXT _retval;
	ELSIF (_ModeBP=0 AND _ModeItem=1) THEN
		--RAISE NOTICE '%', _ModeBP||' -> '||_ModeItem;
		OPEN cRetval FOR 
			SELECT price1, disc1exp, (_total-minamt), tbptype, titemtype
			FROM pprc 
			WHERE active=TRUE 
			AND tbptype='BPGRP' AND fbpgrpin(_BPID, bpgrpid) 
			AND titemtype='TOTAMT' AND minamt<=_Total
			AND (startdate IS NULL OR startdate<=_SaleDate) AND (enddate IS NULL OR enddate>=_SaleDate);
		LOOP
			FETCH cRetval INTO _Price, _DiscExp, _Selisih, _TBPType, _TItemType;
			EXIT WHEN NOT FOUND;
			--RAISE NOTICE '%', _TBPType||' -> '||_TItemType;
			--RAISE NOTICE '%', COALESCE(_Price, 0)||' -> '||COALESCE(_DiscExp, 'disc');
			IF (_OldSelisih IS NULL OR (_Selisih<=_OldSelisih)) THEN
				_OldSelisih:=_Selisih;
				_retval.price:=_Price;
				_retval.discexp:=_DiscExp;
			END IF;
		END LOOP;
		CLOSE cRetval;

		RETURN NEXT _retval;
	ELSIF (_ModeBP=1 AND _ModeItem=0) THEN
		--RAISE NOTICE '%', _ModeBP||' -> '||_ModeItem;
		SELECT INTO _Price, _DiscExp, _Selisih, _TBPType, _TItemType 
			price1, disc1exp, (fqtyztoqty1(_ItemID, _Qty, _Unit)-fqtyztoqty1(itemid, qty, unit)), tbptype, titemtype
		FROM pprc 
		WHERE active=TRUE 
		AND ((tbptype='BPID' AND (custid=_BPID OR vendorid=_BPID)) OR (tbptype='ALL')) 
		AND (
			((titemtype='ITEM' AND itemid=_ItemID) AND unit=_Unit AND qty<=_Qty) OR 
			(titemtype='GROUP' AND itgrpid=(SELECT itgrpid FROM item WHERE itemid=_ItemID)) OR 
			(titemtype='BRAND' AND brandid=(SELECT brandid FROM item WHERE itemid=_ItemID))
		) 
		AND (startdate IS NULL OR startdate<=_SaleDate) AND (enddate IS NULL OR enddate>=_SaleDate);
		IF (FOUND) THEN
			_retval.price:=_Price;
			_retval.discexp:=_DiscExp;
		ELSE
			SELECT INTO _Price, _DiscExp, _Selisih, _TBPType, _TItemType 
				price1, disc1exp, (fqtyztoqty1(_ItemID, _Qty, _Unit)-fqtyztoqty1(itemid, qty, unit)), tbptype, titemtype
			FROM pprc WHERE active=TRUE AND ((tbptype='BPID' AND (custid=_BPID OR vendorid=_BPID)) OR (tbptype='ALL')) 
			AND (
				((titemtype='ITEM' AND itemid=_ItemID) AND unit!=_Unit AND fqtyztoqty1(itemid, qty, unit)<=fqtyztoqty1(_ItemID, _Qty, _Unit)) OR 
				(titemtype='GROUP' AND itgrpid=(SELECT itgrpid FROM item WHERE itemid=_ItemID)) OR 
				(titemtype='BRAND' AND brandid=(SELECT brandid FROM item WHERE itemid=_ItemID))
			) 
			AND (startdate IS NULL OR startdate<=_SaleDate) AND (enddate IS NULL OR enddate>=_SaleDate);
			IF (FOUND) THEN
				_retval.price:=_Price;
				_retval.discexp:=_DiscExp;
			END IF;
		END IF;

		RETURN NEXT _retval;
	ELSIF (_ModeBP=1 AND _ModeItem=1) THEN
		--RAISE NOTICE '%', _ModeBP||' -> '||_ModeItem;
		OPEN cRetval FOR 
			SELECT price1, disc1exp, (_total-minamt), tbptype, titemtype
			FROM pprc WHERE active=TRUE AND ((tbptype='BPID' AND (custid=_BPID OR vendorid=_BPID)) OR (tbptype='ALL')) AND titemtype='TOTAMT' AND minamt<=_Total 
			AND (startdate IS NULL OR startdate<=_SaleDate) AND (enddate IS NULL OR enddate>=_SaleDate);
		LOOP
			FETCH cRetval INTO _Price, _DiscExp, _Selisih, _TBPType, _TItemType;
			EXIT WHEN NOT FOUND;
			--RAISE NOTICE '%', _TBPType||' -> '||_TItemType;
			--RAISE NOTICE '%', COALESCE(_Price, 0)||' -> '||COALESCE(_DiscExp, 'disc');
			IF (_OldSelisih IS NULL OR (_Selisih<=_OldSelisih)) THEN
				_OldSelisih:=_Selisih;
				_retval.price:=_Price;
				_retval.discexp:=_DiscExp;
			END IF;
		END LOOP;
		CLOSE cRetval;

		RETURN NEXT _retval;
	ELSIF (_ModeBP=2 AND _ModeItem=0) THEN
		--RAISE NOTICE '%', _ModeBP||' -> '||_ModeItem;
		SELECT INTO _Price, _DiscExp, _Selisih, _TBPType, _TItemType 
			price1, disc1exp, (fqtyztoqty1(_ItemID, _Qty, _Unit)-fqtyztoqty1(itemid, qty, unit)), tbptype, titemtype
		FROM pprc 
		WHERE active=TRUE AND tbptype='ALL' 
		AND (
			((titemtype='ITEM' AND itemid=_ItemID) AND unit=_Unit AND qty<=_Qty) OR 
			(titemtype='GROUP' AND itgrpid=(SELECT itgrpid FROM item WHERE itemid=_ItemID)) OR 
			(titemtype='BRAND' AND brandid=(SELECT brandid FROM item WHERE itemid=_ItemID))
		) 
		AND (startdate IS NULL OR startdate<=_SaleDate) AND (enddate IS NULL OR enddate>=_SaleDate);
		IF (FOUND) THEN
			_retval.price:=_Price;
			_retval.discexp:=_DiscExp;
		ELSE
			SELECT INTO _Price, _DiscExp, _Selisih, _TBPType, _TItemType 
				price1, disc1exp, (fqtyztoqty1(_ItemID, _Qty, _Unit)-fqtyztoqty1(itemid, qty, unit)), tbptype, titemtype
			FROM pprc 
			WHERE active=TRUE AND tbptype='ALL' 
			AND (
				((titemtype='ITEM' AND itemid=_ItemID) AND unit!=_Unit AND fqtyztoqty1(itemid, qty, unit)<=fqtyztoqty1(_ItemID, _Qty, _Unit)) OR 
				(titemtype='GROUP' AND itgrpid=(SELECT itgrpid FROM item WHERE itemid=_ItemID)) OR 
				(titemtype='BRAND' AND brandid=(SELECT brandid FROM item WHERE itemid=_ItemID))
			) 
			AND (startdate IS NULL OR startdate<=_SaleDate) AND (enddate IS NULL OR enddate>=_SaleDate);
			IF (FOUND) THEN
				_retval.price:=_Price;
				_retval.discexp:=_DiscExp;
			END IF;
		END IF;

		RETURN NEXT _retval;
	ELSIF (_ModeBP=2 AND _ModeItem=1) THEN
		--RAISE NOTICE '%', _ModeBP||' -> '||_ModeItem;
		OPEN cRetval FOR 
			SELECT price1, disc1exp, (_total-minamt), tbptype, titemtype
			FROM pprc WHERE active=TRUE AND tbptype='ALL' AND titemtype='TOTAMT' AND minamt<=_Total
			AND (startdate IS NULL OR startdate<=_SaleDate) AND (enddate IS NULL OR enddate>=_SaleDate);
		LOOP
			FETCH cRetval INTO _Price, _DiscExp, _Selisih, _TBPType, _TItemType;
			EXIT WHEN NOT FOUND;
			--RAISE NOTICE '%', _TBPType||' -> '||_TItemType;
			--RAISE NOTICE '%', COALESCE(_Price, 0)||' -> '||COALESCE(_DiscExp, 'disc');
			IF (_OldSelisih IS NULL OR (_Selisih<=_OldSelisih)) THEN
				_OldSelisih:=_Selisih;
				_retval.price:=_Price;
				_retval.discexp:=_DiscExp;
			END IF;
		END LOOP;
		CLOSE cRetval;

		RETURN NEXT _retval;
	END IF;
END;
$BODY$
LANGUAGE 'plpgsql' VOLATILE;


